# shout/plugs/list.py
#
#

""" lists various stuff. """

## atl imports

from atl.utils import striphtml, ptime, dtime, tdiff
from atl import cmnds, plugins, tools, config, Object
from atl.generic import need_skip, reduced

## basic imports

import datetime
import logging
import time

## list command

def handle_list(event):
    try: p, attrs = event.rest.split(" ", 1) ; attrs = attrs.split()
    except ValueError: p = event.rest ; attrs = []
    if p == "config": event.reply("config is: %s" % " ".join(config.show_items())) ; return
    try: store = getattr(plugins.get(p), "store")
    except AttributeError:
        cmndlist = list(cmnds.keys()) + list(tools.keys())
        event.reply("commands are: %s" % " ".join(cmndlist))
        return
    c = 0
    opts = event.options
    objs = sorted(store.objects(), key=lambda o: o.estamp)
    next = True
    res = []
    otype = opts.otype or "txt"
    for obj in objs:
        if p == "mail" and need_skip(obj, black=["html",], white=["text",]): continue
        if "txt" not in attrs: attrs.append("txt")
        c += 1
        fr = ptime(opts.fr or "1984-01-01")
        to = ptime(opts.to or "2013-12-30")
        try: diff = int(opts.diff)  
        except ValueError: diff = 0
        daysdiff = diff*60*60*24
        if obj.estamp:
            if obj.estamp < fr.timestamp(): continue
            if obj.estamp > to.timestamp(): continue
            if daysdiff and (time.time() - obj.estamp) > daysdiff: continue 
        if obj.estamp: obj.days = datetime.timedelta(-1, time.time() - obj.estamp)
        obj.nr = c
        result = ""
        value = ""
        lines = 0
        attrlist = sorted(reduced(obj))
        for attr in attrlist:
            try:
                value = obj[attr]
                strval = str(value)
                lines += 1
            except KeyError: continue
            if attr in opts:
               if attr.endswith("-excl"): excl = True
               else: excl = False
               val = str(opts[attr]).lower()
               if excl and val in strval.lower(): next = False ; break
               elif val not in strval.lower(): next = False ; break
            if attr not in attrs: continue
            result += '%s: %s ' % (attr, strval)
        if not next: next = True ; continue     
        if result not in res: res.append(result)
        if otype not in ["txt", ]: event.reply(obj.dump() + "\r\n") 
    if otype in ["txt", ]:
        for data in res: event.reply(data)    
    logging.warn("%s objects counted" % c)
    logging.warn("used options: %s" % opts)
 
cmnds.register("list", handle_list)
